import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class SplineTable extends Frame
{  public int Iter,Itermax; public double Err;
   public SplineTable()
   {  setSize(800,300);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double[] setTable(double []X, double[] Y, int N, double DY1, double DYN) // \쐬
   { double []H = new double[N]; double []D = new double[N]; int i;
     double []Table = new double[N]; double T;
     for(i=0; i<N-1; i++) H[i] = X[i + 1] - X[i];
     for(i=1; i<N-1; i++) D[i] = 2 * (X[i + 1] - X[i - 1]);
     double U = (Y[1] - Y[0]) / H[0];
     for(i=1; i<N-1; i++)
     {  T = (Y[i + 1] - Y[i]) / H[i];
        Table[i] = T - U; U = T;
     }
     Table[0]     = DY1 / 6; Table[N-1] = DYN / 6;
     Table[1]     = Table[  1  ] - H[  0  ] * Table[  0 ];
     Table[N - 2] = Table[N - 2] - H[N - 2] * Table[N - 1];
     for(i = 1; i < N - 2; i++)
     {  T = H[i] / D[i]; Table[i + 1] -= Table[i] * T; D[i + 1] -= H[i] * T;
     }
     for(i=N-2; i>=1; i--) Table[i] = (Table[i] - H[i] * Table[i + 1]) / D[i];
     return Table;
   }

   public double FValue(double X){ return (X * X - 1) * X;} // FľvZ

   public double sectInter(double XN, double [] X, double []Y, double[]Table, int  N) // PԂ̕
   { int  i = 0; int j = N - 1;
     while(i < j)
    {  int k = (i + j) / 2;
       if( X[k] < XN) i = k + 1; else j = k;
    }
    if(i > 0) i--;
    double H = X[i + 1] - X[i];
    double T = (XN - X[i]) / H;
    return T * Y[i + 1] + (1 - T) * Y[i] + 
           H * H * (FValue(T) * Table[i + 1] + FValue(1 - T) * Table[i]);
   }
   public double[][] Inter(double []X, double[]Y, double[] Table, int N, int NN)  // Ԃ̌vZ
   {  double XN = X[0];
      double [][]XY =new double[2][NN];
      for(int i=0;i<NN; i++)
      {  XY[0][i] = XN;  XY[1][i] = sectInter(XN, X, Y, Table, N);
         XN += 0.1;
      }
      return XY;
   }
   public int Xpos(double X)
   {  return (int)(X*100)+100;}
   public int Ypos(double Y)
   {  return 400- (int)(Y*50);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void paint(Graphics g)
   { double []  X = { 1,2,3,4,5};
     double []  Y = { 3,5,4,6,4};
     double [] Table = setTable(X, Y, 5, 
                                (Y[1] - Y[0]) / (X[1] - X[0]),
                                (Y[4] - Y[3]) / (X[4] - X[3])); // \쐬
     double [][]  XY= Inter(X,Y,Table, 5, 41);                  // Ԃ̌vZ
     setTitle("XvCԁi֐vZȂ@j");
     g.setColor(new Color(0,0,255));
     for(int i=0;i<=4;i++) drawLine(g,(double)i,0,(double)i,7);
     for(int i=0;i<=7;i++) drawLine(g,0,(double)i,4,(double)i);
     for(int i=1;i<=5;i++) g.drawString(""+i, i*100-4,Ypos(-0.4));
     for(int i=0;i<=7;i++) g.drawString(""+i, Xpos(-0.1),Ypos(i-0.1));
     
     g.setColor(new Color(255,0,0));
    
     for(int i=1;i<41;i++) drawLine(g,XY[0][i-1]-1,XY[1][i-1],XY[0][i]-1,XY[1][i]);
     for(int i=0;i<5;i++)  drawPoint(g,X[i]-1,Y[i]);
     
   } 
   public static void main(String[] args)
   {  Frame w = new SplineTable();
      w.setVisible(true);
   }
}
